/*
 * Fachlicher Schlüssel für JPA Entität
 */
package de.ivu.elect.business.email.entity;

import de.ivu.elect.jee.faces.Messages;
import de.ivu.elect.jee.faces.IMessages;
import java.util.function.Function;

@javax.enterprise.inject.Vetoed
public class EmailVorlageTK
implements de.ivu.elect.jee.entity.tk.EntityTK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

  private final int hashCode;

    protected final java.lang.String bezeichnung;
    public java.lang.String getBezeichnung(){
      return bezeichnung;
    }
  protected final de.ivu.elect.business.wahl.entity.WahlterminTK wahlterminTK;
    public de.ivu.elect.business.wahl.entity.WahlterminTK getWahlterminTK(){
      return wahlterminTK;
    }

  public EmailVorlageTK(
java.lang.String bezeichnung
,   de.ivu.elect.business.wahl.entity.WahlterminTK wahlterminTK
  ) {
    super();


      this.bezeichnung = bezeichnung;
        this.wahlterminTK = wahlterminTK;
  
hashCode = calculateHashCode();
  }

  @Override
  public int hashCode(){
    return hashCode;
  }


  protected int calculateHashCode() {
        int result = 1;
    
    
                    result = result + ((bezeichnung == null) ? 0 : bezeichnung.hashCode());
        
                    result = result + ((wahlterminTK == null) ? 0 : wahlterminTK.hashCode());
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    if (hashCode()!=obj.hashCode()) {
      return false;
    }


            
    if (getClass() != obj.getClass()) {
      if (!(obj instanceof EmailVorlageTK)) {
        return false;
      }

      if (!obj.getClass().isInstance(this)) {
        return obj.equals(this); // equals-Methode aus speziellerer Klasse verwenden
      }

    }

        EmailVorlageTK other = (EmailVorlageTK) obj;

                if (bezeichnung == null) {
          if (other.bezeichnung != null) {
            return false;
          }
        } else if (!bezeichnung.equals(other.bezeichnung)) {
          return false;
        }
        
                if (wahlterminTK == null) {
          if (other.wahlterminTK != null) {
            return false;
          }
        } else if (!wahlterminTK.equals(other.wahlterminTK)) {
          return false;
        }
            return true;
    
  }

  protected boolean hatAttribute() {
        return true;
      }

  @Override
  public String getEntityMessageKey() {
    return EmailVorlageConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    result.addAll(wahlterminTK.getAllEntityFieldValues());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(EmailVorlageConstants.MESSAGE_KEY_ENTITY_EINZAHL, EmailVorlageConstants.MESSAGE_KEY_BEZEICHNUNG_EINZAHL, bezeichnung));
        
        return result;
      }


            @Override
            public String toString() {
            return "EmailVorlageTK[" + toStringParameter() + "]";
            }



            protected String toStringParameter() {
            String result = ""

                                        +"bezeichnung="+bezeichnung
                                        +", wahlterminTK="+wahlterminTK
            
            ;
                            return result;
            
            }

  @Override
  public String toStringLokalisiert(IMessages messages) {
    return messages.getMessageForMessageKey(getEntityMessageKey()) + " ["
            + toStringLokalisiertFields(messages)
            + "]"
            ;
   }

            protected String toStringLokalisiertFields(IMessages messages) {
        return ""
                                      + messages.getMessageForMessageKey(EmailVorlageConstants.MESSAGE_KEY_BEZEICHNUNG_EINZAHL) + "=" + bezeichnung
                                      + ", " +  toStringLokalisiert(wahlterminTK, messages)
                                 ;
      }


            private String toStringLokalisiert(de.ivu.elect.jee.entity.tk.EntityTK entityTK, IMessages messages) {
                if (entityTK != null) {
                    return entityTK.toStringLokalisiert(messages);
                }
                return null;
            }

            public static <E extends EmailVorlage> java.util.Map<EmailVorlageTK, E> mappeEmailVorlageNachTK(java.util.Collection<E> entities) {
                return entities.stream().collect(java.util.stream.Collectors.toMap(EmailVorlage::getEmailVorlageTK, Function.<E>identity(), (u,v)-> v));
                }


                public static Function<EmailVorlage, EmailVorlageTK> getEmailVorlageToTKFunction() {
                return EmailVorlage::getEmailVorlageTK;
                }

}
